#ifndef _IMQBIN_HPP_
#define _IMQBIN_HPP_

//  Library:       MQSeries
//  Component:     IMQB (MQSeries C++ Support)
//  Part:          IMQBIN.HPP
//
//  Description:   "ImqBinary" class declaration
//
//  Statement:     Licensed Materials - Property of IBM
//                 5621-390, 5765-623
//                 (C) Copyright IBM Corp. 1994, 1996
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.

#include <imqitm.hpp> // ImqItem

#define ImqBinary ImqBin

class ImqBinary : public ImqItem {
  void * opvoid ;
  long olLength ;
protected :
  // New methods:
  void clear ( );
public :
  // Overloaded "ImqItem" methods:
  virtual ImqBoolean copyOut ( ImqMsg & );
  virtual ImqBoolean pasteIn ( ImqMsg & );
  // New methods:
  ImqBinary ( );
  ImqBinary ( const ImqBinary & );
  ImqBinary ( const void *, const long );
  virtual ~ ImqBinary ( );
  void operator = ( const ImqBinary & );
  ImqBoolean operator == ( const ImqBinary & ) const ;
  ImqBoolean copyOut ( void *, const long, const char = 0 );
  long dataLength ( ) const { return olLength ; }
  void setDataLength ( const long );
  void * dataPointer ( ) const { return opvoid ; }
  void set ( const void *, const long );
} ;

#endif
