#ifndef _IMQCAC_HPP_
#define _IMQCAC_HPP_

//  Library:       MQSeries
//  Component:     IMQB (MQSeries C++ MQI)
//  Part:          IMQCAC.HPP
//
//  Description:   "ImqCache" class declaration
//
//  Statement:     Licensed Materials - Property of IBM
//                 5621-390, 5765-623
//                 (C) Copyright IBM Corp. 1994, 1996
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.

extern "C" {
#include <imqtype.h>
}

#include <imqerr.hpp> // ImqError

#define ImqCache ImqCac

class ImqCache : public ImqError {
  char * opszBuffer ;
  long olDataOffset ;
  long olBufferLength ;
  long olMessageLength ;
  ImqBoolean obAutomaticBuffer ;
  char ocPadding1[ 3 ];
  // New methods:
  void setAutomaticBuffer ( const ImqBoolean bAutomatic )
    { obAutomaticBuffer = bAutomatic ; }
public :
  // New methods:
  ImqCache ( );
  ImqCache ( const ImqCache & );
  virtual ~ ImqCache ( );
  void operator = ( const ImqCache & );
  ImqBoolean automaticBuffer ( ) const { return obAutomaticBuffer ; }
  long bufferLength ( ) const { return olBufferLength ; }
  char * bufferPointer ( ) const { return opszBuffer ; }
  void clearMessage ( );
  long dataLength ( ) const ;
  long dataOffset ( ) const { return olDataOffset ; }
  char * dataPointer ( ) const { return bufferPointer( ) + dataOffset( ); }
  long messageLength ( ) const { return olMessageLength ; }
  ImqBoolean moreBytes ( const long );
  ImqBoolean read ( const long, char * & );
  ImqBoolean resizeBuffer ( const long );
  ImqBoolean setDataOffset ( const long );
  ImqBoolean setMessageLength ( const long );
  ImqBoolean useEmptyBuffer ( const char *, const long );
  ImqBoolean useFullBuffer ( const char *, const long );
  ImqBoolean write ( const long, const char * );
} ;

#endif
