#ifndef _IMQERR_HPP_
#define _IMQERR_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQERR.HPP
//
//  Description:   "ImqError" class declaration
//
//  Statement:     Licensed Materials - Property of IBM
//                 5621-390, 5765-623
//                 (C) Copyright IBM Corp. 1996
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.

extern "C" {
#include <imqtype.h>
}

#define ImqError ImqErr

class ImqError {
  long olCompletionCode ;
  long olReasonCode ;
protected :
  // New methods:
  void setCompletionCode ( const long lCode = 0 ) { olCompletionCode = lCode ; }
  void setReasonCode ( const long lCode = 0 ) { olReasonCode = lCode ; }
public :
  // New methods:
  ImqError ( );
  ImqError ( const ImqError & );
  virtual ~ ImqError ( );
  void operator = ( const ImqError & );
  void clearErrorCodes ( );
  long completionCode ( ) const { return olCompletionCode ; }
  long reasonCode ( ) const { return olReasonCode ; }
} ;

#endif
