#ifndef _IMQGMO_HPP_
#define _IMQGMO_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQGMO.HPP
//
//  Description:   "ImqGetMessageOptions" class declaration
//
//  Statement:     Licensed Materials - Property of IBM
//                 5621-390, 5765-623
//                 (C) Copyright IBM Corp. 1994, 1996
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.

extern "C" {
#include <cmqc.h>
}

#include <imqerr.hpp> // ImqError
#include <imqstr.hpp> // ImqString

#define ImqGetMessageOptions ImqGmo

class ImqQue ;
class ImqGetMessageOptions : public ImqError {
protected :
  MQGMO omqgmo ;
  friend class ImqQue ;
public :
  // New methods:
  ImqGetMessageOptions ( );
  ImqGetMessageOptions ( const ImqGetMessageOptions & );
  void operator = ( const ImqGetMessageOptions & );
  long options ( ) const { return omqgmo.Options ; }
  ImqString resolvedQueueName ( ) const ;
  void setOptions ( const long lOptions ) { omqgmo.Options = lOptions ; }
  void setSyncPointParticipation ( const ImqBoolean );
  void setWaitInterval ( const long lValue ) { omqgmo.WaitInterval = lValue ; }
  ImqBoolean syncPointParticipation ( ) const ;
  long waitInterval ( ) const { return omqgmo.WaitInterval ; }
} ;

#endif
