#ifndef _IMQHDR_HPP_
#define _IMQHDR_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQHDR.HPP
//
//  Description:   "ImqHeader" class declaration
//
//  Statement:     Licensed Materials - Property of IBM
//                 5621-390, 5765-623
//                 (C) Copyright IBM Corp. 1994, 1996
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.

extern "C" {
#include <cmqc.h>     // MQSeries constants
}

#include <imqstr.hpp> // ImqString

#define ImqHeader ImqHdr

class ImqHeader : public ImqItem {
public :
  // New methods:
  ImqHeader ( );
  ImqHeader ( const ImqHeader & );
  virtual ~ ImqHeader ( );
  void operator = ( const ImqHeader & );
  virtual long characterSet ( ) const = 0 ;
  virtual long encoding ( ) const = 0 ;
  virtual ImqString format ( ) const = 0 ;
  virtual void setCharacterSet ( const long = MQCCSI_Q_MGR ) = 0 ;
  virtual void setEncoding ( const long = MQENC_NATIVE ) = 0 ;
  virtual void setFormat ( const char * = 0 ) = 0 ;
} ;

#endif
